<template>
  <div id="app">
    <div class="docsSelect">
      <b-form-select v-model="selected" :options="options"></b-form-select>
    </div>
    <div id="swaggerUi" />
  </div>
</template>

<script lang="ts">
import Vue from "vue";

import SwaggerUI from "swagger-ui";
import "swagger-ui/dist/swagger-ui.css";

export default Vue.extend({
  name: "App",
  mounted() {
    this.setSwaggerUi();
  },
  data() {
    return {
      options: [
        {
          value: "Coscine.Api.ActivatedFeatures",
          text: "Coscine.Api.ActivatedFeatures",
        },
        { value: "Coscine.Api.Admin", text: "Coscine.Api.Admin" },
        { value: "Coscine.Api.Blob", text: "Coscine.Api.Blob" },
        { value: "Coscine.Api.Metadata", text: "Coscine.Api.Metadata" },
        { value: "Coscine.Api.Organization", text: "Coscine.Api.Organization" },
        { value: "Coscine.Api.Project", text: "Coscine.Api.Project" },
        { value: "Coscine.Api.Quota", text: "Coscine.Api.Quota" },
        { value: "Coscine.Api.Resources", text: "Coscine.Api.Resources" },
        { value: "Coscine.Api.Token", text: "Coscine.Api.Token" },
        { value: "Coscine.Api.Tree", text: "Coscine.Api.Tree" },
        { value: "Coscine.Api.User", text: "Coscine.Api.User" },
      ],
      selected: "Coscine.Api.Project",
    };
  },
  watch: {
    selected() {
      this.setSwaggerUi();
    },
  },
  methods: {
    setSwaggerUi() {
      SwaggerUI({
        domNode: document.getElementById("swaggerUi"),
        url: `https://coscine.rwth-aachen.de/coscine/api/${this.selected}/swagger/v1/swagger.json`,
      });
    },
  },
});
</script>

<style scoped>
.docsSelect {
  display: flex;
  justify-content: center;
  align-items: center;
  margin-top: 60px;
  text-align: center;
}
</style>
